> For the complete documentation index, see [llms.txt](https://docs.ternoa.network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ternoa.network/build-1/javascript/nft-features-and-pallets/sale-your-nft/auction/create-an-english-auction.md).

# Create an English auction

### Prerequisites

Before getting started, make sure you have the following ready:

1. [Create a Ternoa](/getting-started/wallets/ternoa-wallet.md) account with [Alphanet CAPS](broken://pages/ej9gceaLIhCN2PgUBh42)
2. Install and set up your editor of choice (we will use Visual Studio Code \[VSC] in this tutorial)
3. Install [NodeJS v.14+](https://nodejs.org/en/download/) & NPM
4. [Install & initialize Ternoa-JS](/build-1/javascript/ternoa-js-library-utilities/installation-and-initialization.md)

### Create an auction on a marketplace using Ternoa-JS

This function puts an existing NFT to auction on a marketplace on the Ternoa chain. It returns an object promise containing the AuctionCreatedEvent provided by the Ternoa blockchain.

{% hint style="info" %}
Use your own account by updating the `//TernoaTestAccount` with your account seed when retrieving the keyring from the example below. **Replace the NFT\_ID** with the existing one to auction, the **MARKETPLACE\_ID** by the existing marketplace id you want the NFT to be auctioned on, the **startBlock**, **endBlock**, **startPrice**, **buyItPrice**.&#x20;
{% endhint %}

```typescript
import {
    createAuction,
    initializeApi,
    getKeyringFromSeed,
    WaitUntil,
} from "ternoa-js";

const listAuctionNFT = async () => {
    try {
        await initializeApi();
        const keyring = await getKeyringFromSeed("//TernoaTestAccount");
        const NFT_ID = // update with the nft id you want to auction.
        const MARKETPLACE_ID = // update with the marketplace id you want the NFT to be auctioned on.
        const startBlock = // update with the auction start block number.
        const endBlock = // update with the auction end block number.
        const startPrice = // update with the auction start price.
        const buyItPrice = // update with the auction "buy it now" price.
        const res = await createAuction(
            NFT_ID,
            MARKETPLACE_ID,
            startBlock,
            endBlock,
            startPrice,
            buyItPrice,
            keyring,
            WaitUntil.BlockInclusion
        );
        console.log(`NFT id: ${res.nftId} auctioned on marketplace ${res.marketplaceId} for ${res.startPrice}CAPS`);
    } catch (e) {
        console.error(e);
    }
};
```

#### The expected params

```markdown
`nftId`: The ID of the NFT.
`marketplaceId`: The ID of the marketplace where the auction will take place.
`startBlock`: The ID of the block at which the auction starts.
`endBlock`: The ID of the block at which the auction ends.
`startPrice`: The price at which the auction starts.
`buyItPrice`: The price to directly buy the NFT before the auction starts. Optional Parameter.
`keyring`: The provided keyring (containing the address) will be used to sign the transaction and pay the execution fee.
`waitUntil`: WaitUntil defines at which point we want to get the results of the transaction execution: BlockInclusion or BlockFinalization.
```

#### Response

The response provided from the blockchain event includes all the information below according to the parameters provided when buying an NFT.

```markdown
`nftId`: NFT id auctioned.
`marketplaceId`: Marketplace id where the NFT was listed for auction.
`creator`: The auction creator.
`startPrice`: The starting auction price of the NFT as a string corresponding to the value in a big number.
`startPriceRounded`: The starting auction price of the NFT as a number.
`buyItPrice`: If set, the price to directly buy the NFT before the auction starts as a string corresponding to the value in a big number.
`buyItPriceRounded`: If set, The price to directly buy the NFT before the auction starts as a number.
`startBlock`: The auction starting block number.
`endBlock`: The auction ending block number.
```

### Support

If you face any trouble, feel free to reach out to our community engineers in our [Discord](https://discord.gg/fUmBkPpnRu).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ternoa.network/build-1/javascript/nft-features-and-pallets/sale-your-nft/auction/create-an-english-auction.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
